## fcitx 4.2.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(fcitx)

set(version 4.2.7)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
set_property(GLOBAL PROPERTY "__FCITX_INTERNAL_BUILD" On)

option(ENABLE_X11 "Enable X11 as dependency" ON)
option(ENABLE_GLIB2 "Enable GLib2 as depenedency" ON)
option(ENABLE_CAIRO "Enable Cairo" ON)
option(ENABLE_DBUS "Enable DBus Support" ON)
option(ENABLE_PANGO "Enable Pango Support" ON)
option(ENABLE_LIBXML2 "Enable libxml2" ON)
option(ENABLE_DEBUG "Enable Debug" OFF)
option(ENABLE_TABLE "Enable Table IM" ON)
option(ENABLE_GTK2_IM_MODULE "Enable GTK2 IM Module" ON)
option(ENABLE_GTK3_IM_MODULE "Enable GTK3 IM Module" OFF)
option(ENABLE_QT "Enable Qt-based lib and configuration GUI" On)
option(ENABLE_QT_IM_MODULE "Enable Qt IM Module" ON)
option(ENABLE_OPENCC "Enable OpenCC for Chinese Transform" ON)
option(FORCE_OPENCC
  "Enable opencc even if the library is not found at compile time" Off)
option(ENABLE_LUA "Enable Lua support" OFF)
option(ENABLE_STATIC "Build Static Library" OFF)
option(ENABLE_TEST "Test build" OFF)
option(ENABLE_SNOOPER "Enable Key Snooper for gtk app" On)
option(ENABLE_GIR "Enable GObject Introspection" On)
option(ENABLE_ENCHANT "Enable enchant for word predication" On)
option(ENABLE_PRESAGE "Enable presage for word predication" On)
option(FORCE_ENCHANT
  "Enable enchant even if the library is not found at compile time" Off)
option(FORCE_PRESAGE
  "Enable presage even if the library is not found at compile time" Off)
option(ENABLE_ICU "Enable icu for qt/keyboard compose" On)
option(ENABLE_BACKTRACE "Enable backtrace support" On)
option(ENABLE_XDGAUTOSTART "Enable xdg autostart desktop file installion" On)
option(ENABLE_GETTEXT "Enable gettext support." On)

if(NOT NO_SNOOPER_APPS)
  set(NO_SNOOPER_APPS ".*chrome.*,.*chromium.*,firefox.*,Do.*"
    CACHE STRING "Disable Key Snooper for following app")
endif()

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(FindPkgConfig)
include(UseDoxygen OPTIONAL)
include(FcitxMacro)

_fcitx_add_uninstall_target()
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(malloc.h HAVE_MALLOC_H)
check_include_files(stdbool.h HAVE_STDBOOL_H)
check_function_exists(asprintf HAVE_ASPRINTF)

find_package(Libintl REQUIRED)
find_package(Libiconv REQUIRED)
find_package(Pthread REQUIRED)
find_package(Libexecinfo)
find_package(GettextPo)

if(NOT ENABLE_GETTEXT OR NOT GETTEXTPO_FOUND)
  fcitx_disable_gettext()
endif()

if(LIBEXECINFO_LIB_FOUND)
  set(ENABLE_BACKTRACE 1)
else()
  set(ENABLE_BACKTRACE 0)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "BSD")
  find_package(Libkvm REQUIRED)
endif(${CMAKE_SYSTEM_NAME} MATCHES "BSD")
find_package(DL REQUIRED)
if(ENABLE_ENCHANT)
  find_package(Enchant)
  if(NOT (ENCHANT_FOUND OR FORCE_ENCHANT))
    set(ENABLE_ENCHANT Off)
  endif()
endif()
if (ENABLE_LIBXML2)
    find_package(LibXml2 REQUIRED)
    find_package(IsoCodes REQUIRED)
    find_package(XkbFile REQUIRED)
endif (ENABLE_LIBXML2)
if(ENABLE_PRESAGE)
  find_package(Presage)
  if(NOT (PRESAGE_FOUND OR FORCE_PRESAGE))
    set(ENABLE_PRESAGE Off)
  endif()
endif()
if(ENABLE_ICU)
  find_package(ICU REQUIRED)
endif()

if(ENABLE_QT)
  find_package(Qt4 4.5 COMPONENTS QtCore QtGui QtDBus REQUIRED)
endif()

if(ENABLE_X11)
find_package(X11 REQUIRED)

if (NOT X11_Xkb_FOUND)
    message(FATAL_ERROR "Xkb is needed")
endif (NOT X11_Xkb_FOUND)

find_program(some_x_program NAMES iceauth xrdb xterm)
if (NOT some_x_program)
    _pkgconfig_invoke("x11" PC_X11 PREFIX "" "--variable=prefix")
    if (PC_X11_PREFIX)
        set(some_x_program "${PC_X11_PREFIX}/bin/xrdb")
    else (PC_X11_PREFIX)
        set(some_x_program /usr/bin/xrdb)
        message("Warning: Could not determine X binary directory. Assuming /usr/bin.")
    endif (PC_X11_PREFIX)
endif (NOT some_x_program)
get_filename_component(proto_xbindir "${some_x_program}" PATH)
get_filename_component(XBINDIR "${proto_xbindir}" ABSOLUTE)
get_filename_component(xrootdir "${XBINDIR}" PATH)
set(XLIBDIR "${xrootdir}/lib/X11")
endif(ENABLE_X11)

if (ENABLE_TEST)
    ENABLE_TESTING()
endif (ENABLE_TEST)

set(_ENABLE_CAIRO 0)
set(_ENABLE_PANGO 0)
if (ENABLE_X11 AND ENABLE_CAIRO)
    PKG_CHECK_MODULES(CAIRO_XLIB REQUIRED "cairo-xlib>=1.0" )
    if (CAIRO_XLIB_FOUND)
        set(_ENABLE_CAIRO 1)
    endif (CAIRO_XLIB_FOUND)
endif (ENABLE_X11 AND ENABLE_CAIRO)

set(_ENABLE_PANGO 0)
if (_ENABLE_CAIRO AND ENABLE_GLIB2)
    if (ENABLE_PANGO)
        PKG_CHECK_MODULES(PANGOCAIRO "pangocairo>=1.0" )
        if (PANGOCAIRO_FOUND)
            set(_ENABLE_PANGO 1)
        endif (PANGOCAIRO_FOUND)
    endif (ENABLE_PANGO)
    if (NOT _ENABLE_PANGO)
        PKG_CHECK_MODULES(FONTCONFIG REQUIRED "fontconfig")
    endif (NOT _ENABLE_PANGO)
endif(_ENABLE_CAIRO AND ENABLE_GLIB2)

set(_ENABLE_DBUS 0)
if (ENABLE_DBUS)
    PKG_CHECK_MODULES(DBUS "dbus-1>=1.1.0" )
    if (DBUS_FOUND)
        set(_ENABLE_DBUS 1)
    endif (DBUS_FOUND)
endif (ENABLE_DBUS)

if(ENABLE_OPENCC)
    find_package(OpenCC)
    if(NOT (OPENCC_FOUND OR FORCE_OPENCC))
        set(ENABLE_OPENCC Off)
    endif()
endif()

set(HAVE_XINERAMA 0)
if (X11_Xinerama_FOUND)
    set(HAVE_XINERAMA 1)
endif (X11_Xinerama_FOUND)

if (X11_Xfixes_FOUND)
    set(HAVE_XFIXES 1)
endif (X11_Xfixes_FOUND)

if(ENABLE_DEBUG)
    set(_DEBUG ON)
endif(ENABLE_DEBUG)

set(package     fcitx)
set(prefix      ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(bindir ${exec_prefix}/bin)

if(NOT DEFINED LIB_INSTALL_DIR)
    set(LIB_INSTALL_DIR ${exec_prefix}/lib)
endif()
if(NOT DEFINED LIBDATA_INSTALL_DIR)
    set(LIBDATA_INSTALL_DIR ${LIB_INSTALL_DIR})
endif()
if(NOT DEFINED MAN_INSTALL_DIR)
    set(MAN_INSTALL_DIR ${prefix}/share/man)
endif()

set(includedir "${CMAKE_INSTALL_PREFIX}/include")
set(libdir ${LIB_INSTALL_DIR})
set(pkgconfdir ${LIBDATA_INSTALL_DIR}/pkgconfig)
set(mandir ${MAN_INSTALL_DIR})
set(addondir ${libdir}/${package} )
set(pkgdatadir ${prefix}/share/${package})
set(configdescdir ${pkgdatadir}/configdesc)
set(addonconfigdir ${pkgdatadir}/addon)
set(imconfigdir ${pkgdatadir}/inputmethod)
set(localedir ${CMAKE_INSTALL_PREFIX}/share/locale)

list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemPlatformLibDir)
list(FIND CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemCxxLibDir)
if("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")
    set(CMAKE_SKIP_BUILD_RPATH  FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH "${LIB_INSTALL_DIR}")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")

# For FcitxMacro
set(FCITX4_ADDON_INSTALL_DIR ${addondir})
set(FCITX4_CONFIGDESC_INSTALL_DIR ${configdescdir})
set(FCITX4_ADDON_CONFIG_INSTALL_DIR ${addonconfigdir})
set(FCITX4_INPUTMETHOD_CONFIG_INSTALL_DIR ${imconfigdir})
set(FCITX4_PACKAGE_NAME ${package})

if (NOT DEFINED OPENCC_LIBRARY_FILENAME)
  set(OPENCC_LIBRARY_FILENAME
    "${CMAKE_SHARED_LIBRARY_PREFIX}opencc${CMAKE_SHARED_LIBRARY_SUFFIX}")
endif()

if(NOT DEFINED ENCHANT_LIBRARY_FILENAME)
  set(ENCHANT_LIBRARY_FILENAME
    "${CMAKE_SHARED_LIBRARY_PREFIX}enchant${CMAKE_SHARED_LIBRARY_SUFFIX}")
endif()
if(NOT DEFINED PRESAGE_LIBRARY_FILENAME)
  set(PRESAGE_LIBRARY_FILENAME
    "${CMAKE_SHARED_LIBRARY_PREFIX}presage${CMAKE_SHARED_LIBRARY_SUFFIX}")
endif()

set(CMAKE_C_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_C_FLAGS}")
set(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_CXX_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_SHARED_LINKER_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_MODULE_LINKER_FLAGS}")
add_definitions("-D_GNU_SOURCE -DFCITX_HAVE_CONFIG_H")

configure_file(${PROJECT_SOURCE_DIR}/config.h.in ${PROJECT_BINARY_DIR}/config.h)
configure_file("${PROJECT_SOURCE_DIR}/cmake/FcitxConfigVersion.cmake.in"
               "${PROJECT_BINARY_DIR}/cmake/FcitxConfigVersion.cmake"
                IMMEDIATE @ONLY
)

include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_BINARY_DIR}/src/)
include_directories(${PROJECT_SOURCE_DIR}/src/)
include_directories(${PROJECT_SOURCE_DIR}/src/lib/)

# must be the first
add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(skin)
add_subdirectory(tools)
add_subdirectory(data)
add_subdirectory(cmake)

if(ENABLE_TEST)
  add_subdirectory(test)
endif()

=== cmake/CMakeLists.txt ===
install(FILES FcitxConfig.cmake FcitxMacro.cmake
  "${CMAKE_CURRENT_BINARY_DIR}/FcitxConfigVersion.cmake"
  DESTINATION "${prefix}/share/cmake/fcitx/")
install(FILES
  fcitx-merge-config.sh
  fcitx-cmake-helper.sh
  fcitx-extract-gettext.sh
  fcitx-extract-confdesc.sh
  fcitx-extract-desktop.sh
  fcitx-extract-po.sh
  fcitx-extract-qt.sh
  fcitx-extract-kde.sh
  DESTINATION "${prefix}/share/cmake/fcitx/"
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
  GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
install(FILES
  fcitx-parse-po.sh
  fcitx-write-po.sh
  DESTINATION "${prefix}/share/cmake/fcitx/"
  PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

=== data/CMakeLists.txt ===
if(ENABLE_TABLE)
  add_subdirectory(table)
endif()
fcitx_translate_add_sources(
  table/qxm.conf.in
  table/wbx.conf.in
  table/wanfeng.conf.in
  table/db.conf.in
  table/wbpy.conf.in
  table/erbi.conf.in
  table/zrm.conf.in
  table/cangjie.conf.in
  )

add_subdirectory(script)
add_subdirectory(icon)

set(FCITX_DESC_FILES
  addon.desc
  config.desc
  profile.desc
  inputmethod.desc
  )

set(FCITX_DATA_FILES
  AutoEng.dat
  gbks2t.tab
  punc.mb.zh_CN
  punc.mb.zh_HK
  punc.mb.zh_TW
  vk.conf
  )

set(FCITX_PY_FILES
  pySym.mb
  sp.dat
  )

set(FCITX_DSEKTOP_FILES
  fcitx.desktop
  fcitx-configtool.desktop
  fcitx-autostart.desktop
  )

set(PY_ORGDATA pyPhrase.org)
set(PY_DATA "${CMAKE_CURRENT_BINARY_DIR}/pybase.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/pyphrase.mb")
set(PY_TAR pinyin.tar.gz)
set(PY_URL "http://fcitx.googlecode.com/files/pinyin.tar.gz")

fcitx_translate_add_sources(
  fcitx-configtool.desktop.in
  fcitx.desktop.in
  fcitx-autostart.desktop.in)
fcitx_translate_add_apply_source(
  fcitx-configtool.desktop.in
  "${CMAKE_CURRENT_BINARY_DIR}/fcitx-configtool.desktop")
fcitx_translate_add_apply_source(
  fcitx.desktop.in
  "${CMAKE_CURRENT_BINARY_DIR}/fcitx.desktop")
fcitx_translate_add_apply_source(
  fcitx-autostart.desktop.in
  "${CMAKE_CURRENT_BINARY_DIR}/fcitx-autostart.desktop")

add_custom_target(pinyin_data ALL DEPENDS ${PY_DATA})

fcitx_download(py-data-download "${PY_URL}" "${PY_TAR}"
  MD5SUM 34dcb1b5209c28baa4e87f6a2773bfd0)
fcitx_extract(py-data-extract "${PY_TAR}" DEPENDS py-data-download
  OUTPUT ${PY_ORGDATA})
set(CREATE_PYMB_BIN "${PROJECT_BINARY_DIR}/tools/cli/createPYMB")
add_custom_command(OUTPUT ${PY_DATA}
  DEPENDS ${PY_ORGDATA} "${CREATE_PYMB_BIN}" py-data-extract
  COMMAND "${CREATE_PYMB_BIN}" "${CMAKE_CURRENT_SOURCE_DIR}/gbkpy.org"
  "${CMAKE_CURRENT_BINARY_DIR}/${PY_ORGDATA}")

add_custom_target(desktopfile ALL DEPENDS ${FCITX_DSEKTOP_FILES})
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fcitx.desktop"
  DESTINATION share/applications/)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fcitx-configtool.desktop"
  DESTINATION share/applications/)

install(FILES ${FCITX_DATA_FILES} DESTINATION "${pkgdatadir}/data")
fcitx_install_addon_desc(${FCITX_DESC_FILES})
install(FILES ${FCITX_PY_FILES} "${CMAKE_CURRENT_BINARY_DIR}/pybase.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/pyphrase.mb" DESTINATION "${pkgdatadir}/pinyin")

set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
  "${CMAKE_CURRENT_BINARY_DIR}/pyERROR;${CMAKE_CURRENT_BINARY_DIR}/pyPhrase.ok")

if(_ENABLE_DBUS AND ENABLE_XDGAUTOSTART)
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fcitx-autostart.desktop"
    DESTINATION /etc/xdg/autostart)
endif()

if(_ENABLE_DBUS)
  install(FILES daemon.conf DESTINATION share/fcitx/dbus/)
endif()

set(PY_STROKE_VER 20121124)
set(PY_STROKE_TGT "${CMAKE_CURRENT_BINARY_DIR}/py_stroke.mb")
set(PY_STROKE_TAR "py_stroke-${PY_STROKE_VER}.tar.gz")
set(PY_STROKE_URL
  "http://fcitx.googlecode.com/files/py_stroke-${PY_STROKE_VER}.tar.gz")
fcitx_download(py-stroke-download "${PY_STROKE_URL}" "${PY_STROKE_TAR}"
  MD5SUM 2559d025c5bbb50fa450a02429f92762)
fcitx_extract(py-stroke-extract "${PY_STROKE_TAR}" DEPENDS py-stroke-download
  OUTPUT ${PY_STROKE_TGT})
install(FILES "${PY_STROKE_TGT}" DESTINATION "${pkgdatadir}/py-enhance")

set(PY_TABLE_VER 20121124)
set(PY_TABLE_TGT "${CMAKE_CURRENT_BINARY_DIR}/py_table.mb")
set(PY_TABLE_TAR "py_table-${PY_TABLE_VER}.tar.gz")
set(PY_TABLE_URL
  "http://fcitx.googlecode.com/files/py_table-${PY_TABLE_VER}.tar.gz")
fcitx_download(py-table-download "${PY_TABLE_URL}" "${PY_TABLE_TAR}"
  MD5SUM a72e275fe1916d67d01a2f038ca5d920)
fcitx_extract(py-table-extract "${PY_TABLE_TAR}" DEPENDS py-table-download
  OUTPUT ${PY_TABLE_TGT})
install(FILES "${PY_TABLE_TGT}" DESTINATION "${pkgdatadir}/py-enhance")

set(SPELL_EN_DICT_VER 20121020)
set(SPELL_EN_DICT "${CMAKE_CURRENT_BINARY_DIR}/en_dict.fscd")
set(SPELL_EN_DICT_SRC "${CMAKE_CURRENT_BINARY_DIR}/en_dict.txt")
set(SPELL_EN_DICT_TAR "en_dict-${SPELL_EN_DICT_VER}.tar.gz")
set(SPELL_EN_DICT_URL
  "http://fcitx.googlecode.com/files/en_dict-${SPELL_EN_DICT_VER}.tar.gz")

fcitx_download(spell-en-download "${SPELL_EN_DICT_URL}" "${SPELL_EN_DICT_TAR}"
  MD5SUM 8315f85331e0545c256a46e0cb00f10f)
fcitx_extract(spell-en-extract "${SPELL_EN_DICT_TAR}" DEPENDS spell-en-download
  OUTPUT ${SPELL_EN_DICT_SRC})

set(COMP_SPELL_DICT
  "${PROJECT_BINARY_DIR}/src/module/spell/dict/comp-spell-dict")
add_custom_command(
  OUTPUT "${SPELL_EN_DICT}"
  DEPENDS "${SPELL_EN_DICT_SRC}" "${COMP_SPELL_DICT}" spell-en-extract
  COMMAND "${COMP_SPELL_DICT}" "${SPELL_EN_DICT_SRC}" "${SPELL_EN_DICT}")
add_custom_target(spell_en_dict ALL DEPENDS "${SPELL_EN_DICT}")
install(FILES "${SPELL_EN_DICT}" DESTINATION "${pkgdatadir}/spell")

=== test/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/lib)
include_directories(${PROJECT_SOURCE_DIR}/src/im/pinyin)
include_directories(${PROJECT_SOURCE_DIR}/src/module/unicode)
include_directories(${PROJECT_SOURCE_DIR}/src/module/dbus)

add_executable(testbacktrace testbacktrace.c)
target_link_libraries(testbacktrace fcitx-utils)

add_executable(testconfig testconfig.c)
target_link_libraries(testconfig fcitx-config)

add_executable(testmessage testmessage.c)
target_link_libraries(testmessage fcitx-core)

add_executable(teststring teststring.c)
target_link_libraries(teststring fcitx-utils)

add_executable(testarray testarray.c)
target_link_libraries(testarray fcitx-utils)

add_executable(testutf8 testutf8.c)
target_link_libraries(testutf8 fcitx-utils)

add_executable(testxdg testxdg.c)
target_link_libraries(testxdg fcitx-config fcitx-utils)

add_executable(testunicode testunicode.c ../src/module/unicode/charselectdata.c)
target_link_libraries(testunicode fcitx-utils fcitx-config)

add_executable(testobjpool testobjpool.c)
target_link_libraries(testobjpool fcitx-utils)

add_executable(testcast testcast.c)
target_link_libraries(testcast fcitx-utils)

add_executable(testhandlertable testhandlertable.c)
target_link_libraries(testhandlertable fcitx-utils)

add_executable(testhotkey testhotkey.c)
target_link_libraries(testhotkey fcitx-config)

add_executable(testpinyin
    ../src/im/pinyin/pyParser.c
    ../src/im/pinyin/pyMapTable.c
    ../src/im/pinyin/PYFA.c
    ../src/im/pinyin/sp.c
    testpinyin.c
)

target_link_libraries(testpinyin fcitx-config)

add_executable(testdbuslaunch testdbuslaunch.c
               ../src/module/dbus/dbuslauncher.c
               )

target_link_libraries(testdbuslaunch fcitx-utils)

add_test(NAME testconfig
         COMMAND testconfig ${CMAKE_CURRENT_SOURCE_DIR}/test.desc ${CMAKE_CURRENT_SOURCE_DIR}/test.conf ${CMAKE_CURRENT_BINARY_DIR}/test.conf)

add_test(NAME testmessage
         COMMAND testmessage)

add_test(NAME testbacktrace
         COMMAND testbacktrace)

add_test(NAME testpinyin
         COMMAND testpinyin)

add_test(NAME teststring
         COMMAND teststring)

add_test(NAME testarray
         COMMAND testarray)

add_test(NAME testobjpool
         COMMAND testobjpool)

add_test(NAME testcast
         COMMAND testcast)

add_test(NAME testhandlertable
         COMMAND testhandlertable)

add_test(NAME testutf8
         COMMAND testutf8)

add_test(NAME testxdg
         COMMAND testxdg)

add_test(NAME testunicode
         COMMAND testunicode ${PROJECT_SOURCE_DIR}/src/module/unicode/charselectdata)

add_test(NAME testdbuslaunch
         COMMAND testdbuslaunch)

add_test(NAME testhotkey
         COMMAND testhotkey)

=== data/icon/CMakeLists.txt ===
foreach(size 16 22 24 32 48 128)
    install(DIRECTORY ${size}x${size} DESTINATION share/icons/hicolor
             PATTERN .* EXCLUDE
             PATTERN *~ EXCLUDE)
endforeach(size 16 22 24 32 48 128)

install(DIRECTORY scalable DESTINATION share/icons/hicolor
         PATTERN ".*" EXCLUDE
         PATTERN "*~" EXCLUDE)

install(DIRECTORY symbolic/scalable DESTINATION share/icons/gnome
         PATTERN ".*" EXCLUDE
         PATTERN "*~" EXCLUDE )

=== data/script/CMakeLists.txt ===
install(FILES fcitx-configtool DESTINATION "${bindir}"
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
  GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

configure_file(fcitx4-config.in "${CMAKE_CURRENT_BINARY_DIR}/fcitx4-config")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx4-config
  DESTINATION "${bindir}" PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
  GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

if(_ENABLE_DBUS AND ENABLE_XDGAUTOSTART)
  install(FILES fcitx-autostart DESTINATION "${bindir}"
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
    GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
endif()

fcitx_translate_add_sources(fcitx-diagnose.sh)
install(FILES fcitx-diagnose.sh DESTINATION "${bindir}" RENAME fcitx-diagnose
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
  GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

=== data/table/CMakeLists.txt ===
set(TXT2MB_BIN "${PROJECT_BINARY_DIR}/tools/cli/txt2mb")

set(TABLE_DATA
  "${CMAKE_CURRENT_BINARY_DIR}/db.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/erbi.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/qxm.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/wanfeng.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/wbpy.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/wbx.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/zrm.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/cj.mb"
  )
set(TABLEORG_DATA db.txt erbi.txt qxm.txt wanfeng.txt
  wbpy.txt wbx.txt zrm.txt cj.txt)
set(TABLE_NAME db erbi qxm wanfeng wbpy wbx zrm cj)
set(TABLE_CONF db.conf erbi.conf qxm.conf wanfeng.conf
  wbpy.conf wbx.conf zrm.conf cangjie.conf)
set(TABLE_URL http://fcitx.googlecode.com/files/table.tar.gz)
set(TABLE_TAR ${CMAKE_CURRENT_SOURCE_DIR}/table.tar.gz)

foreach(tableconffile ${TABLE_CONF})
  fcitx_translate_add_apply_source(
    "${CMAKE_CURRENT_SOURCE_DIR}/${tableconffile}.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${tableconffile}")
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${tableconffile}"
    DESTINATION "${pkgdatadir}/table")
endforeach()
add_custom_target(table_data ALL DEPENDS ${TABLE_DATA})

fcitx_download(table-data-download "${TABLE_URL}" "${TABLE_TAR}"
  MD5SUM acb0b112423474ab2c1a22cee590d636)
fcitx_extract(table-data-extract "${TABLE_TAR}" DEPENDS table-data-download
  OUTPUT ${TABLEORG_DATA})

foreach(tblname ${TABLE_NAME})
  add_custom_command(OUTPUT ${tblname}.mb
    DEPENDS ${tblname}.txt "${TXT2MB_BIN}" table-data-extract
    COMMAND "${TXT2MB_BIN}" ${tblname}.txt ${tblname}.mb)
endforeach()

install(FILES ${TABLE_DATA} DESTINATION ${pkgdatadir}/table )

=== src/module/CMakeLists.txt ===
add_subdirectory(x11)

if(ENABLE_X11 AND ENABLE_LIBXML2)
  set(_ENABLE_XKB On)
else()
  set(_ENABLE_XKB Off)
endif()
add_subdirectory(xkb)

if(_ENABLE_DBUS AND _ENABLE_XKB)
  set(_ENABLE_XKBDBUS On)
else()
  set(_ENABLE_XKBDBUS Off)
endif()
add_subdirectory(xkbdbus)

add_subdirectory(chttrans)
add_subdirectory(punc)
add_subdirectory(spell)
add_subdirectory(pinyin-enhance)
add_subdirectory(quickphrase)
add_subdirectory(autoeng)
add_subdirectory(fullwidthchar)
add_subdirectory(remote)
add_subdirectory(imselector)
add_subdirectory(clipboard)
add_subdirectory(vk)
add_subdirectory(dbus)
add_subdirectory(lua)
add_subdirectory(unicode)

=== tools/dev/CMakeLists.txt ===
set(fcitx_scanner_SOURCES
  fcitx-scanner.c
  )

add_executable(fcitx-scanner ${fcitx_scanner_SOURCES})
target_link_libraries(fcitx-scanner fcitx-utils)

set(fcitx_po_parser_SOURCES
  fcitx-po-parser.c
  )

if(NOT _FCITX_DISABLE_GETTEXT)
  include_directories(${GETTEXTPO_INCLUDE_DIR})
endif()

add_executable(fcitx-po-parser ${fcitx_po_parser_SOURCES})

if(NOT _FCITX_DISABLE_GETTEXT)
  target_link_libraries(fcitx-po-parser fcitx-utils ${GETTEXTPO_LIBRARIES})
endif()

install(TARGETS fcitx-scanner fcitx-po-parser DESTINATION ${bindir})

=== src/frontend/gtk2/CMakeLists.txt ===
set(FCITX_GTK2_IM_MODULE_GIO_SOURCES
  fcitxim.c
  fcitximcontext-gio.c
  )
set(FCITX_GTK2_IM_MODULE_NO_GIO_SOURCES
  fcitxim.c
  fcitximcontext.c
  client.c
  )

fcitx_translate_add_sources(${FCITX_GTK2_IM_MODULE_NO_GIO_SOURCES}
  ${FCITX_GTK2_IM_MODULE_GIO_SOURCES})

set(FCITX_GTK2_IM_MODULE_NO_GIO_SOURCES
  ${FCITX_GTK2_IM_MODULE_NO_GIO_SOURCES}
  "${CMAKE_CURRENT_BINARY_DIR}/marshall.c"
  "${CMAKE_CURRENT_BINARY_DIR}/marshall.h"
  )

if(NOT ENABLE_GTK2_IM_MODULE)
  return()
endif()

PKG_CHECK_MODULES(GTK2 REQUIRED "gtk+-2.0" )
_pkgconfig_invoke("gtk+-2.0" GTK2 BINARY_VERSION
  "" "--variable=gtk_binary_version")
_pkgconfig_invoke("gtk+-2.0" GTK2 LIBDIR "" "--variable=libdir")
set(GTK2_IM_MODULEDIR
  "${GTK2_LIBDIR}/gtk-2.0/${GTK2_BINARY_VERSION}/immodules")

include_directories(${GTK2_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
link_directories(${GTK2_LIBRARY_DIRS})

add_custom_command(OUTPUT marshall.c
  COMMAND ${GLIB_GENMARSHAL} --body --prefix=fcitx_marshall
  ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.c
  DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list)
add_custom_command(OUTPUT marshall.h
  COMMAND ${GLIB_GENMARSHAL} --header --prefix=fcitx_marshall
  ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.h
  DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list)

if(GIO2_FOUND)
  include_directories(${GIO2_INCLUDE_DIRS})
  link_directories(${GIO2_LIBRARY_DIRS})

  set(FCITX_GTK2_IM_MODULE_SOURCES ${FCITX_GTK2_IM_MODULE_GIO_SOURCES})
else()
  include_directories(${DBUS_GLIB_INCLUDE_DIRS})
  link_directories(${DBUS_GLIB_LIBRARY_DIRS})

  set(FCITX_GTK2_IM_MODULE_SOURCES ${FCITX_GTK2_IM_MODULE_NO_GIO_SOURCES})
endif()

add_library(im-fcitx MODULE ${FCITX_GTK2_IM_MODULE_SOURCES})
set_target_properties( im-fcitx PROPERTIES PREFIX ""
  COMPILE_FLAGS "-fvisibility=hidden" LINK_FLAGS "-Wl,--no-undefined")
target_link_libraries(im-fcitx ${GTK2_LIBRARIES} fcitx-utils)
if(GIO2_FOUND)
  target_link_libraries(im-fcitx ${GTK2_LIBRARIES} ${GIO2_LIBRARIES}
    fcitx-gclient fcitx-utils)
else()
  target_link_libraries(im-fcitx ${GTK2_LIBRARIES} ${DBUS_GLIB_LIBRARIES}
    fcitx-utils)
endif()
install(TARGETS im-fcitx DESTINATION "${GTK2_IM_MODULEDIR}")

=== src/frontend/ipc/CMakeLists.txt ===
set(FCITX_IPC_LINK_LIBS)
if(_ENABLE_DBUS)
  include_directories(${DBUS_INCLUDE_DIRS})
  link_directories(${DBUS_LIBRARY_DIRS})
  set(FCITX_IPC_LINK_LIBS ${FCITX_IPC_LINK_LIBS} ${DBUS_LIBRARIES})
  set(ipc_noinstall)
else()
  set(ipc_noinstall NO_INSTALL)
endif()

set(FCITX_IPC_SOURCES
  ipc.c
  )

fcitx_add_addon_full(ipc ${ipc_noinstall}
  SOURCES ${FCITX_IPC_SOURCES}
  HEADERS ipc.h
  LINK_LIBS ${FCITX_IPC_LINK_LIBS})

=== src/im/pinyin/CMakeLists.txt ===
set(FCITX_PINYIN_SOURCES
  py.c
  PYFA.c
  pyMapTable.c
  pyParser.c
  sp.c
  pyconfig.c
  )
set(FCITX_PINYIN_HEADERS
  PYFA.h
  pyconfig.h
  py.h
  pysplitdata.h
  pyParser.h
  spdata.h
  pyMapTable.h
  sp.h
  pydef.h
  )

fcitx_add_addon_full(pinyin SCAN SCAN_PRIV DESC
  SOURCES ${FCITX_PINYIN_SOURCES}
  HEADERS pydef.h
  IM_CONFIG pinyin.conf shuangpin.conf
  EXTRA_PO ${FCITX_PINYIN_HEADERS})

=== debian/changelog ===
fcitx (1:4.2.7-1ubuntu1) raring; urgency=low

  * Add upstream indicator patches

 -- Aron Xu <happyaron@ubuntu.com>  Wed, 13 Feb 2013 13:50:37 +0800

fcitx (1:4.2.7-1) unstable; urgency=low

  * New upstream release.
  * New binary packages:
    - fcitx-libs-gclient: D-Bus client library for Glib
    - fcitx-libs-qt: D-Bus client library for Qt
    - fcitx-module-quickphrase-editor: Quick Phrase editor module

 -- Aron Xu <aron@debian.org>  Sun, 10 Feb 2013 17:03:56 +0800

=== debian/rules ===
#!/usr/bin/make -f
include debian/variables.mk
include debian/gencontrol.mk
%:
	dh $@ --with gir
override_dh_auto_clean: gen_control
	dh_auto_clean
override_dh_auto_configure: gen_control
	dh_auto_configure -- \
	    -DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	    -DENABLE_CAIRO=ON \
	    -DENABLE_DBUS=ON \
	    -DENABLE_PANGO=ON \
	    -DENABLE_DEBUG=ON \
	    -DENABLE_TABLE=ON \
	    -DENABLE_GTK2_IM_MODULE=ON \
	    -DENABLE_GTK3_IM_MODULE=ON \
	    -DENABLE_QT_IM_MODULE=ON \
	    -DENABLE_OPENCC=ON \
	    -DENABLE_LUA=ON \
	    -DENABLE_STATIC=ON \
	    -DENABLE_TEST=ON \
	    -DENABLE_SNOOPER=ON \
	    -DENABLE_GIR=ON
override_dh_install:
	dh_install --fail-missing
override_dh_makeshlibs:
	dh_makeshlibs -pfcitx-libs
	dh_makeshlibs -pfcitx-libs-gclient
	dh_makeshlibs -pfcitx-libs-qt
override_dh_strip:
	dh_strip --dbg-package=fcitx-dbg

=== debian/watch ===
version=3
http://code.google.com/p/fcitx/downloads/list .*/fcitx-([0-9]\.*.*)_dict\.tar\.xz

## fcitx 4.2.8.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,12 @@
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8.6)
 
 project(fcitx)
 
-set(version 4.2.7)
+set(version 4.2.8.1)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
+set(CMAKE_AUTOMOC_RELAXED_MODE TRUE)
+
 set_property(GLOBAL PROPERTY "__FCITX_INTERNAL_BUILD" On)
 
 option(ENABLE_X11 "Enable X11 as dependency" ON)
@@ -14,11 +16,13 @@
 option(ENABLE_PANGO "Enable Pango Support" ON)
 option(ENABLE_LIBXML2 "Enable libxml2" ON)
 option(ENABLE_DEBUG "Enable Debug" OFF)
+option(ENABLE_PINYIN "Enable Pinyin" ON)
 option(ENABLE_TABLE "Enable Table IM" ON)
 option(ENABLE_GTK2_IM_MODULE "Enable GTK2 IM Module" ON)
 option(ENABLE_GTK3_IM_MODULE "Enable GTK3 IM Module" OFF)
-option(ENABLE_QT "Enable Qt-based lib and configuration GUI" On)
+option(ENABLE_QT "Enable Qt-based lib" On)
 option(ENABLE_QT_IM_MODULE "Enable Qt IM Module" ON)
+option(ENABLE_QT_GUI "Enable Qt-based configuration GUI" On)
 option(ENABLE_OPENCC "Enable OpenCC for Chinese Transform" ON)
 option(FORCE_OPENCC
   "Enable opencc even if the library is not found at compile time" Off)
@@ -219,18 +223,50 @@
 set(FCITX4_INPUTMETHOD_CONFIG_INSTALL_DIR ${imconfigdir})
 set(FCITX4_PACKAGE_NAME ${package})
 
+function(_RESOLVE_LIBRARY_PATH _FILE_NAME _LIBRARY_PATH)
+    if (CMAKE_OBJDUMP)
+        execute_process (
+            COMMAND ${CMAKE_OBJDUMP} -p "${_LIBRARY_PATH}"
+            RESULT_VARIABLE STATUS
+            OUTPUT_VARIABLE OBJDUMP_RESULT
+            ERROR_QUIET
+        )
+        string(REGEX REPLACE ".*SONAME +([^ ]+)\n.*$" "\\1" SONAME_OUT "${OBJDUMP_RESULT}")
+        if (SONAME_OUT)
+            set(_FILE_NAME_OUT "${SONAME_OUT}")
+        endif ()
+    endif()
+    if (NOT _FILE_NAME_OUT)
+        get_filename_component(_FILE_NAME_OUT "${_LIBRARY_PATH}" NAME)
+    endif()
+    set(${_FILE_NAME} ${_FILE_NAME_OUT} PARENT_SCOPE)
+endfunction()
+
+
 if (NOT DEFINED OPENCC_LIBRARY_FILENAME)
-  set(OPENCC_LIBRARY_FILENAME
-    "${CMAKE_SHARED_LIBRARY_PREFIX}opencc${CMAKE_SHARED_LIBRARY_SUFFIX}")
+    if (OPENCC_LIBRARIES)
+        _RESOLVE_LIBRARY_PATH(OPENCC_LIBRARY_FILENAME "${OPENCC_LIBRARIES}")
+    else ()
+        set(OPENCC_LIBRARY_FILENAME
+            "${CMAKE_SHARED_LIBRARY_PREFIX}opencc${CMAKE_SHARED_LIBRARY_SUFFIX}")
+    endif ()
 endif()
 
 if(NOT DEFINED ENCHANT_LIBRARY_FILENAME)
-  set(ENCHANT_LIBRARY_FILENAME
-    "${CMAKE_SHARED_LIBRARY_PREFIX}enchant${CMAKE_SHARED_LIBRARY_SUFFIX}")
+    if (ENCHANT_LIBRARIES)
+        _RESOLVE_LIBRARY_PATH(ENCHANT_LIBRARY_FILENAME "${ENCHANT_LIBRARIES}")
+    else ()
+        set(ENCHANT_LIBRARY_FILENAME
+            "${CMAKE_SHARED_LIBRARY_PREFIX}enchant${CMAKE_SHARED_LIBRARY_SUFFIX}")
+    endif ()
 endif()
 if(NOT DEFINED PRESAGE_LIBRARY_FILENAME)
-  set(PRESAGE_LIBRARY_FILENAME
-    "${CMAKE_SHARED_LIBRARY_PREFIX}presage${CMAKE_SHARED_LIBRARY_SUFFIX}")
+    if (PRESAGE_LIBRARIES)
+        _RESOLVE_LIBRARY_PATH(PRESAGE_LIBRARY_FILENAME "${PRESAGE_LIBRARIES}")
+    else ()
+        set(PRESAGE_LIBRARY_FILENAME
+            "${CMAKE_SHARED_LIBRARY_PREFIX}presage${CMAKE_SHARED_LIBRARY_SUFFIX}")
+    endif ()
 endif()
 
 set(CMAKE_C_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_C_FLAGS}")

=== data/CMakeLists.txt ===
add_subdirectory(script)
add_subdirectory(icon)

set(FCITX_DESC_FILES
  addon.desc
  config.desc
  profile.desc
  inputmethod.desc
  )

set(FCITX_DATA_FILES
  AutoEng.dat
  gbks2t.tab
  punc.mb.zh_CN
  punc.mb.zh_HK
  punc.mb.zh_TW
  vk.conf
  )

set(FCITX_PY_FILES
  pySym.mb
  sp.dat
  )

set(FCITX_DSEKTOP_FILES
  fcitx.desktop
  fcitx-configtool.desktop
  fcitx-autostart.desktop
  )

fcitx_translate_add_sources(
  fcitx-configtool.desktop.in
  fcitx.desktop.in
  fcitx-autostart.desktop.in)
fcitx_translate_add_apply_source(
  fcitx-configtool.desktop.in
  "${CMAKE_CURRENT_BINARY_DIR}/fcitx-configtool.desktop")
fcitx_translate_add_apply_source(
  fcitx.desktop.in
  "${CMAKE_CURRENT_BINARY_DIR}/fcitx.desktop")
fcitx_translate_add_apply_source(
  fcitx-autostart.desktop.in
  "${CMAKE_CURRENT_BINARY_DIR}/fcitx-autostart.desktop")

add_custom_target(desktopfile ALL DEPENDS ${FCITX_DSEKTOP_FILES})
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fcitx.desktop"
  DESTINATION share/applications/)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fcitx-configtool.desktop"
  DESTINATION share/applications/)

install(FILES ${FCITX_DATA_FILES} DESTINATION "${pkgdatadir}/data")
fcitx_install_addon_desc(${FCITX_DESC_FILES})

if(_ENABLE_DBUS AND ENABLE_XDGAUTOSTART)
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fcitx-autostart.desktop"
    DESTINATION /etc/xdg/autostart)
endif()

if(_ENABLE_DBUS)
  install(FILES daemon.conf DESTINATION share/fcitx/dbus/)
endif()

=== src/frontend/gtk3/CMakeLists.txt ===
if(NOT ENABLE_GTK3_IM_MODULE)
  return()
endif()
PKG_CHECK_MODULES(GTK3 REQUIRED "gtk+-3.0" )

_pkgconfig_invoke("gtk+-3.0" GTK3 BINARY_VERSION
  "" "--variable=gtk_binary_version")
_pkgconfig_invoke("gtk+-3.0" GTK3 LIBDIR "" "--variable=libdir")
set(GTK3_IM_MODULEDIR
  "${GTK3_LIBDIR}/gtk-3.0/${GTK3_BINARY_VERSION}/immodules")

include_directories(${GTK3_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
link_directories(${GTK3_LIBRARY_DIRS})

if(GIO2_FOUND)
  include_directories(${GIO2_INCLUDE_DIRS})
  link_directories(${GIO2_LIBRARY_DIRS})

  set(FCITX_GTK3_IM_MODULE_SOURCES
    fcitxim.c
    fcitximcontext-gio.c)
else()
  include_directories(${DBUS_GLIB_INCLUDE_DIRS})
  link_directories(${DBUS_GLIB_LIBRARY_DIRS})

  add_custom_command(OUTPUT marshall.c
    COMMAND ${GLIB_GENMARSHAL} --body --prefix=fcitx_marshall
    ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.c
    DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list)
  add_custom_command(OUTPUT marshall.h
    COMMAND ${GLIB_GENMARSHAL} --header --prefix=fcitx_marshall
    ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.h
    DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list)

  set(FCITX_GTK3_IM_MODULE_SOURCES
    fcitxim.c
    fcitximcontext.c
    client.c
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.c
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.h
    )
endif()

add_library(im-fcitx-gtk3 MODULE ${FCITX_GTK3_IM_MODULE_SOURCES})
set_target_properties( im-fcitx-gtk3 PROPERTIES PREFIX ""
  COMPILE_FLAGS "-fvisibility=hidden" OUTPUT_NAME "im-fcitx"
  LINK_FLAGS "-Wl,--no-undefined")

if(GIO2_FOUND)
  target_link_libraries(im-fcitx-gtk3 ${GTK3_LIBRARIES} ${GIO2_LIBRARIES}
    fcitx-gclient fcitx-utils)
else()
  target_link_libraries(im-fcitx-gtk3 ${GTK3_LIBRARIES}
    ${DBUS_GLIB_LIBRARIES} fcitx-utils)
endif()
install(TARGETS im-fcitx-gtk3 DESTINATION "${GTK3_IM_MODULEDIR}")

=== src/module/dbus/CMakeLists.txt ===
set(FCITX_DBUS_LINK_LIBS)
if(_ENABLE_DBUS)
  include_directories(${DBUS_INCLUDE_DIRS})
  link_directories(${DBUS_LIBRARY_DIRS})
  set(FCITX_DBUS_LINK_LIBS ${FCITX_DBUS_LINK_LIBS}
    ${DBUS_LIBRARIES})
  set(dbus_noinstall)
else()
  set(dbus_noinstall NO_INSTALL)
endif()

set(FCITX_DBUS_SOURCES
  dbussocket.c
  dbusstuff.c
  dbuslauncher.c
  )

fcitx_add_addon_full(dbus SCAN SCAN_PRIV ${dbus_noinstall}
  SOURCES ${FCITX_DBUS_SOURCES}
  HEADERS dbusstuff.h
  LINK_LIBS ${FCITX_DBUS_LINK_LIBS})

set(FCITX_DBUS_WATCHER_SOURCES
  dbussocket.c
  watcher.c
  )
set(FCITX_DBUS_REMOTE_SOURCES
  dbusremote.c
  )

fcitx_translate_add_sources(${FCITX_DBUS_REMOTE_SOURCES}
  ${FCITX_DBUS_WATCHER_SOURCES})

if(_ENABLE_DBUS)
  add_executable(fcitx-dbus-watcher ${FCITX_DBUS_WATCHER_SOURCES})
  target_link_libraries(fcitx-dbus-watcher ${DBUS_LIBRARIES} fcitx-utils)
  install(TARGETS fcitx-dbus-watcher DESTINATION "${bindir}")
  add_executable(fcitx-dbus-remote ${FCITX_DBUS_REMOTE_SOURCES})
  set_target_properties(fcitx-dbus-remote PROPERTIES OUTPUT_NAME fcitx-remote)
  target_link_libraries(fcitx-dbus-remote ${DBUS_LIBRARIES}
    fcitx-config fcitx-utils)
  install(TARGETS fcitx-dbus-remote DESTINATION "${bindir}")
endif()

=== debian/changelog ===
fcitx (1:4.2.8.1-3) unstable; urgency=low

  * Update dependency versions.
  * fcitx-ui-classic: replaces and breaks fcitx-hangul (<< 0.3.0)
    (Closes: #718644)

 -- Aron Xu <aron@debian.org>  Sun, 04 Aug 2013 12:26:10 +0800

fcitx (1:4.2.8.1-2) unstable; urgency=low

  * Mark some inline symbols as optional in fcitx-libs-qt.
  * fcitx-ui-classic: replaces and breaks fcitx-unikey (<< 0.2.0)
    due to file move (Closes: #718314).

 -- YunQiang Su <wzssyqa@gmail.com>  Wed, 31 Jul 2013 00:31:25 +0800

fcitx (1:4.2.8.1-1) unstable; urgency=low

  * modify d/watch for new download site
  * Imported Upstream version 4.2.8.1
  * fcitx-scanner and fcitx-po-parser now installed to
       usr/lib/*/fcitx/libexec/
    comp-spell-dict also installed into usr/lib/*/fcitx/libexec
  * Remove patches included upstream
     - 0004-Upstream-post-release-changes.patch
     - 0005-fix-bashism-problems.patch
  * Update symbols for libs
  * Install emoji.mb and latex.mb into package
    fcitx-module-quickphrase-editor

 -- YunQiang Su <wzssyqa@gmail.com>  Mon, 29 Jul 2013 21:46:03 +0800

fcitx (1:4.2.7-2) unstable; urgency=low

  [ Wang Diancheng ]
  * Disable debug messages, use Release build type

  [ Aron Xu ]
  * Add Breaks/Replaces to fcitx-libs-gclient (Closes: #700710)

  [ YunQiang Su ]
  * fix bashism problems (Closes: #701553, #701558)
  * Remove FcitxQtInputMethodProxy::CreateIC from qt symbols (Closes: #701276)

 -- YunQiang Su <wzssyqa@gmail.com>  Thu, 28 Feb 2013 17:00:35 +0800

=== debian/control ===
Source: fcitx
Section: utils
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: Aron Xu <aron@debian.org>, YunQiang Su <wzssyqa@gmail.com>
Build-Depends: debhelper (>= 9), cmake, liblua5.2-dev | liblua5.1-0-dev,
    libdbus-1-dev (>= 1.1.0), libpango1.0-dev (>= 1.0), libcairo2-dev (>= 1.0),
    libopencc-dev (>= 0.1.1~), libicu-dev, x11proto-xinerama-dev,
    libgtk2.0-dev, libqt4-dev, libgtk-3-dev, libkvm-dev [kfreebsd-any],
    libenchant-dev, libpresage-dev, libxml2-dev, libxkbfile-dev, gobject-introspection,
    libgirepository1.0-dev, iso-codes, libxfixes-dev, libpthread-stubs0-dev, libgettextpo-dev
Standards-Version: 3.9.4
Homepage: http://code.google.com/p/fcitx/
Vcs-Git: git://anonscm.debian.org/pkg-ime/fcitx.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ime/fcitx.git

Package: fcitx
Architecture: all
Depends: ${misc:Depends}, fcitx-bin, fcitx-data, fcitx-modules
Recommends: fcitx-config-gtk | kde-config-fcitx,
    fcitx-frontend-all | fcitx-frontend-fbterm,
    fcitx-ui-classic | fcitx-ui-light,
    im-config (>= 0.5) | im-switch
Suggests: fcitx-tools, fcitx-m17n
Description: Flexible Input Method Framework
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This metapackage pulls in a set of components recommended for most desktop
 users.

Package: fcitx-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: fcitx-data, fcitx-modules
Suggests: fcitx (>= 1:4.2.8)
Replaces: fcitx (<< 1:4.2.8)
Breaks: fcitx (<< 1:4.2.8)
Description: Flexible Input Method Framework - essential binaries
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the essential executable binaries. If you are
 looking for a working input experience, please install the package 
 "fcitx" instead.

Package: fcitx-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: fcitx-bin
Suggests: fcitx (>= 1:4.2.8)
Replaces: fcitx (<< 1:4.2.8)
Breaks: fcitx (<< 1:4.2.8)
Description: Flexible Input Method Framework - essential data files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the essential data files. If you are looking for a
 working input experience, please install the package "fcitx" instead.

Package: fcitx-libs
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: fcitx-libs-gclient, fcitx-libs-qt
Suggests: fcitx (>= 1:4.2.8)
Replaces: fcitx (<< 1:4.2.8)
Breaks: fcitx (<< 1:4.2.8)
Description: Flexible Input Method Framework - library files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains three libraries:
  * libfcitx-core - core functions of Fcitx
  * libfcitx-config - support library for Fcitx configurations
  * libfcitx-utils - utility support library for Fcitx

Package: fcitx-libs-gclient
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-libs
Suggests: fcitx (>= 1:4.2.8)
Replaces: fcitx (<< 1:4.2.8), fcitx-libs (<< 1:4.2.7)
Breaks: fcitx (<< 1:4.2.8), fcitx-libs (<< 1:4.2.7)
Description: Flexible Input Method Framework - D-Bus client library for Glib
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains the following library:
  * libfcitx-gclient - D-Bus client library for Glib

Package: fcitx-libs-qt
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-libs
Suggests: fcitx (>= 1:4.2.8)
Replaces: fcitx (<< 1:4.2.8)
Breaks: fcitx (<< 1:4.2.8)
Description: Flexible Input Method Framework - D-Bus client library for Qt
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains the following library:
  * libfcitx-qt - D-Bus client library for Qt

Package: fcitx-libs-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, fcitx-libs (= ${binary:Version}),
 fcitx-libs-gclient (= ${binary:Version}), fcitx-libs-qt (= ${binary:Version})
Replaces: fcitx (<< 1:4.2.8)
Breaks: fcitx (<< 1:4.2.8)
Recommends: fcitx-bin (>= 1:4.2.8)
Description: Flexible Input Method Framework - library development files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the library development files.

Package: gir1.2-fcitx-1.0
Architecture: any
Section: introspection
Depends: ${gir:Depends}, ${misc:Depends}
Suggests: fcitx (>= 1:4.2.8)
Replaces: fcitx (<< 1:4.2.8)
Breaks: fcitx (<< 1:4.2.8)
Description: Flexible Input Method Framework - GObject introspection 
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package can be used by other packages using the GIRepository format to
 generate dynamic bindings.

Package: fcitx-dbg
Architecture: any
Section: debug
Priority: extra
Multi-Arch: same
Depends: ${misc:Depends}, fcitx-libs (= ${binary:Version})
Replaces: fcitx (<< 1:4.2.8)
Breaks: fcitx (<< 1:4.2.8)
Description: Flexible Input Method Framework - debugging symbols
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the debugging symbols of the whole Fcitx.

Package: fcitx-ui-classic
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-x11
Recommends: fcitx (>= 1:4.2.8), zenity
Replaces: fcitx (<< 1:4.2.8), fcitx-unikey (<< 0.2.0), fcitx-hangul (<< 0.3.0)
Breaks: fcitx (<< 1:4.2.8), fcitx-unikey (<< 0.2.0), fcitx-hangul (<< 0.3.0)
Description: Flexible Input Method Framework - Classic user interface
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the classic user interface, which is suitable 
 for most users. It also provides the following skins:
  * classic: Fcitx 3.x classic skin ported to new infrastructure
  * dark: the dark skin fits for dark desktop theme
  * default: the default skin

Package: fcitx-frontend-all
Architecture: all
Depends: ${misc:Depends}
Recommends: fcitx-frontend-gtk2, fcitx-frontend-gtk3, fcitx-frontend-qt4
Description: Flexible Input Method Framework - frontends metapackage
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This metapackage pulls in the following frontends:
  * XIM protocol client
  * GTK+ 2/3 IM Module
  * QT 4 IM Module

Package: fcitx-frontend-gtk2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-dbus
Recommends: fcitx-frontend-gtk3
Description: Flexible Input Method Framework - GTK+ 2 IM Module frontend
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the GTK+ 2 IM Module frontend, which is
 recommended for all desktop users.

Package: fcitx-frontend-gtk3
Architecture: any
Multi-Arch: same

=== debian/rules ===
--- 
+++ 
@@ -7,11 +7,11 @@
 	dh_auto_clean
 override_dh_auto_configure: gen_control
 	dh_auto_configure -- \
+	    -DCMAKE_BUILD_TYPE=Release \
 	    -DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
 	    -DENABLE_CAIRO=ON \
 	    -DENABLE_DBUS=ON \
 	    -DENABLE_PANGO=ON \
-	    -DENABLE_DEBUG=ON \
 	    -DENABLE_TABLE=ON \
 	    -DENABLE_GTK2_IM_MODULE=ON \
 	    -DENABLE_GTK3_IM_MODULE=ON \
